/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDicomValue;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
/**
* This item class contains the methods to set, get and validate the attribute present in Ion Control Point Sequence.
 */

public class IonControlPointSequenceItem extends Item  
{

	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 */
	IonControlPointSequenceItem()
	{
		super();
	}

	/**
	 * This constructor creates the item and internal code sequence macro with default TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	IonControlPointSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates IonControlPointSequenceItem with specified TransferSyntax and
	 * specified DictionaryReader
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used 
	 */
	IonControlPointSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}
	/**
	 * Validates all the attributes in Corrected Parameter Sequence Item that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Mandatory or Conditional element fails.
	 */
	public boolean validateForModule()  throws InvalidItemException
	{
		try
		{
			//validation of mandatory elements
			if(!contains(0x300A,0x0112))
				throw new MandatoryMissingException("300A,0112");
			if(!contains(0x300A,0x0134))
				throw new MandatoryMissingException("0x300A,0x0134");
			
		}	
		catch( MandatoryMissingException me)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(me.getMessage());
			}
			throw new ValidationException(this.getClass().getSimpleName(),me);
		}
		return true;
	}
	
	/**
	 * Sets Index of current Control Point, starting at 0 for first Control Point.
	 * @param strControlPointIndex String value of Control Point Index.
	 */
	public void setControlPointIndex(String strControlPointIndex)
	{
		/*Accept the ControlPointIndex in String format of type IS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x300A,0x0112, strControlPointIndex,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x300A,0x0112,DicomConstants.DCM_DT_IS, strControlPointIndex);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves Index of current Control Point, starting at 0 for first Control Point.
	 * @return String - value of Control Point Index.
	 */
	public String getControlPointIndex()
	{
		Object objValue = getValue(0x300A,0x0112);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets Cumulative weight to current control point. It is always zero for first item in Control Point Sequence and 
	 * Cumulative Meterset Weight for the final item in Control Point Sequence shall always be equal to Final Cumulative Meterset Weight.
	 * @param strCumulativeMetersetWeight String value of Cumulative Meterset Weight.
	 */
	public void setCumulativeMetersetWeight(String strCumulativeMetersetWeight)
	{
		/*Accept the CumulativeMetersetWeight in String format of type DS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x300A,0x0134, strCumulativeMetersetWeight,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x300A,0x0134,DicomConstants.DCM_DT_DS, strCumulativeMetersetWeight);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves  Cumulative weight to current control point.
	 * @return String - value of Cumulative Meterset Weight.
	 */
	public String getCumulativeMetersetWeight()
	{
		Object objValue = getValue(0x300A,0x0134);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	

	/**
	 * Retrieves pre-initialized object of Referenced Dose Reference Sequence.If the module contains the sequence object
	 * it returns the same otherwise it creates the sequence adds to the module with proper initialization
	 * and then returns the object of sequence
	 * @return ReferencedDoseReferenceSequence - instance of Referenced Dose Reference Sequence. 
	 */
	public ReferencedDoseReferenceSequence getReferencedDoseReferenceSequence()
	{
		ReferencedDoseReferenceSequence objReferencedDoseReferenceSequence = null;
		IDataElement objIDataElement =  getDataForTag(0x300C,0x0050);
		if(objIDataElement != null)
		{
			IDicomValue objIDicomValue = objIDataElement.getDicomValue();
			if(objIDicomValue != null)
				objReferencedDoseReferenceSequence = (ReferencedDoseReferenceSequence)objIDicomValue;
		}
		else
		{
			DicomV3Factory objDicomV3Factory = DicomV3Factory.createInstance();
			int iVRTransferSyntax = objITransferSyntax.getVRTransferSyntax();
			objIDataElement = null;
			objReferencedDoseReferenceSequence = (ReferencedDoseReferenceSequence)objDicomV3Factory.createSequence(0x300C,0x0050, objITransferSyntax, objIDictionaryReader);

			if(iVRTransferSyntax == DicomConstants.DCM_VR_IMPLICIT)
				objIDataElement = new ImplicitDE(0x300C,0x0050, objReferencedDoseReferenceSequence.getValue(),objIDictionaryReader);
			else
				objIDataElement = new ExplicitDE(0x300C,0x0050, DicomConstants.DCM_DT_SQ, objReferencedDoseReferenceSequence.getValue());
			objIDataElement.setTransferSyntax(objITransferSyntax);
			if(objIDataElement != null)
				addDataElement(objIDataElement);
		}
		return objReferencedDoseReferenceSequence;
	}
}
